
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "about.h"

#include "ocean.xpm"

GtkWidget *dlg=NULL;

void open_about(void)
{
  GtkWidget *v1,*h1;
  GtkStyle *style;
  GdkPixmap *pix;
  GdkBitmap *mask;
  GtkWidget *img,*lbl;
  char tmp[512];
  
  if (dlg!=NULL)
    return;

  dlg=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_default_size(GTK_WINDOW(dlg),380,240);
  gtk_window_set_title(GTK_WINDOW(dlg),"About Porto Seguro...");
  gtk_window_set_position(GTK_WINDOW(dlg),GTK_WIN_POS_CENTER);
  gtk_window_set_policy(GTK_WINDOW(dlg),TRUE,TRUE,TRUE);
  gtk_widget_realize(dlg);

  v1=gtk_vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(dlg),v1);

  style=gtk_widget_get_style(dlg);

  pix=gdk_pixmap_create_from_xpm_d (dlg->window, &mask,
				   &style->bg[GTK_STATE_NORMAL],
				   (gchar **) ocean_xpm);
  img=gtk_pixmap_new(pix,mask);
  gdk_pixmap_unref(pix);
  gtk_box_pack_start(GTK_BOX(v1),img,TRUE,TRUE,0);

  sprintf(tmp,"Porto Seguro\nLight Application Launcher\nVersion %s\n"\
	      "(C) 2000 Felipe Bergo [bergo@seul.org]\n"\
	      "This program is distributed under the terms of the GNU\n"\
              "General Public License, version 2 or later.",
	  RELEASE);

  h1=gtk_hbox_new(FALSE,0);

  lbl=gtk_label_new(tmp);
  gtk_label_set_justify(GTK_LABEL(lbl),GTK_JUSTIFY_LEFT);

  gtk_box_pack_start(GTK_BOX(v1),h1,FALSE,TRUE,0);
  gtk_box_pack_start(GTK_BOX(h1),lbl,FALSE,FALSE,4);

  gtk_widget_show(img);
  gtk_widget_show(lbl);
  gtk_widget_show(h1);
  gtk_widget_show(v1);
  gtk_widget_show(dlg);

  gtk_signal_connect(GTK_OBJECT(dlg),"delete_event",
		     GTK_SIGNAL_FUNC(wanna_die),NULL);
  gtk_signal_connect(GTK_OBJECT(dlg),"destroy",
		     GTK_SIGNAL_FUNC(is_dead),NULL);
}

gboolean wanna_die(GtkWidget *w,GdkEvent *e,gpointer data)
{
  return FALSE;
}

gboolean is_dead(GtkWidget *w,gpointer data)
{
  dlg=NULL;
  return FALSE;
}

