/*

    PortoSeguro - Light Application Launcher
    Copyright (C) 2000 Felipe Paulo Guazzi Bergo
    bergo@seul.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "common.h"

void strip_n(char *s)
{
  while(s[strlen(s)-1]=='\n')
    s[strlen(s)-1]=0;
}


void assure_icon(char *s,char **paths,int count)
{
  int i;
  char tmp[512];
  if (file_exists(s))
    return;
  for(i=0;i<count;i++) {
    if (try_prefix(s,paths[i])) {
      sprintf(tmp,"%s/%s",paths[i],s);
      strcpy(s,tmp);
      return;
    }
  }
}

int try_prefix(char *s,char *prefix)
{
  char tmp[512];
  sprintf(tmp,"%s/%s",prefix,s);
  return(file_exists(tmp));
}

int file_exists(char *s)
{
  FILE *f;
  f=fopen(s,"r");
  if (f==NULL)
    return 0;
  fclose(f);
  return 1;
}
