/*

    PortoSeguro - Light Application Launcher
    Copyright (C) 2000 Felipe Paulo Guazzi Bergo
    bergo@seul.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/types.h>
#include <gtk/gtk.h>
#include "conf.h"
#include "common.h"
#include "pixmap.h"

#include "graydock.xpm"

#include "cmd_new.xpm"
#include "cmd_del.xpm"
#include "cmd_dup.xpm"
#include "cmd_up.xpm"
#include "cmd_down.xpm"

int bcount;
struct PortoSeguro bdock[40];
GtkWidget *mw,*wi[50],*wj[20];
GtkObject *ob[10];
int selected_entry=-1,cur_pixpath=-1;

struct HueMask active_hue;

int speed=3;
static int speed_v[5]={2,3,6,11,22};

int halign,valign;

int icon_path_count=0;
char icon_paths[50][256];
char *icon_path_p[50];

int main(int argc,char **argv)
{
  int i;

  for(i=0;i<50;i++)
    icon_path_p[i]=&(icon_paths[i][0]);

  gtk_init(&argc,&argv);
  gdk_rgb_init();

  read_rc();
  open_conf();
  update_list();

  gtk_main();
  exit(0);
}

void save_rc(void)
{
  FILE *f;
  char *p,tmp[256];
  int i;

  p=getenv("HOME");
  sprintf(tmp,"%s/.PortoSeguro",p);
  f=fopen(tmp,"w");
  if (!f)
    return;

  for(i=0;i<bcount;i++) {
    fprintf(f,"#Item#\n");
    fprintf(f,"%s\n%s\n%d\n%d\n\n",bdock[i].icon,bdock[i].exec,
	    bdock[i].hold,bdock[i].applet);
  }

  fprintf(f,"#ActivatedColor#\n%.4f %.4f %.4f\n\n",
	  active_hue.r,active_hue.g,active_hue.b);
  fprintf(f,"#Place#\n%d %d\n\n",
	  halign,valign);
  fprintf(f,"#AnimeSpeed#\n%d\n\n",
	  speed_v[speed]);

  if (icon_path_count) {
    fprintf(f,"#IconPath#\n");
    for(i=0;i<icon_path_count;i++)
      fprintf(f,"%s\n",icon_paths[i]);
    fprintf(f,"#IconPath#\n\n");
  }

  fclose(f);

  sprintf(tmp,"%s/.PortoSeguroDock.update.yourself",p);
  f=fopen(tmp,"w");
  if (f) {
    fprintf(f,"hello\n");
    fclose(f);
  }
}

void read_rc(void)
{
  char *p,tmp[256],aux[256];
  FILE *f;
  int i;

  bcount=0;
  active_hue.r=0.6667;
  active_hue.g=0.6667;
  active_hue.b=1.0000;

  halign=valign=1;
  speed=3;
  
  p=getenv("HOME");
  sprintf(tmp,"%s/.sapphire/PortoSeguro",getenv("HOME"));
  f=fopen(tmp,"r");

  if (!f) {
    sprintf(tmp,"%s/.PortoSeguro",getenv("HOME"));
    f=fopen(tmp,"r");
    if (!f)
      return;
  }

  while(fgets(tmp,511,f)) {
    if (strstr(tmp,"#AnimeSpeed#")) {
      fgets(aux,255,f);
      speed=atoi(strtok(aux," \t\n"));
      for(i=0;i<5;i++)
	if (speed==speed_v[i]) {
	  speed=i;
	  break;
	}
    }
    if (strstr(tmp,"#Place#")) {
      fgets(aux,255,f);
      halign=atoi(strtok(aux," \t\n"));
      valign=atoi(strtok(NULL," \t\n"));
    }
    if (strstr(tmp,"#ActivatedColor#")) {
      fgets(aux,255,f);
      active_hue.r=atof(strtok(aux," \t\n"));
      active_hue.g=atof(strtok(NULL," \t\n"));
      active_hue.b=atof(strtok(NULL," \t\n"));
    }
    if (strstr(tmp,"#Item#")) {
      fgets(bdock[bcount].icon,255,f);
      strip_n(bdock[bcount].icon);
      fgets(bdock[bcount].exec,511,f);
      strip_n(bdock[bcount].exec);
      fgets(tmp,511,f);
      strip_n(tmp);
      bdock[bcount].hold=atoi(tmp);
      assure_icon(bdock[bcount].icon,icon_path_p,icon_path_count);
      fgets(tmp,511,f);
      strip_n(tmp);
      bdock[bcount].applet=atoi(tmp);
      bcount++;
    }
    if (strstr(tmp,"#IconPath#")) {
      icon_path_count=0;
      while(1) {
	fgets(icon_paths[icon_path_count],255,f);
	if (strstr(icon_paths[icon_path_count],"#IconPath#"))
	  break;
	strip_n(icon_paths[icon_path_count++]);
      }
    }
  }
  fclose(f);

  if (!icon_path_count) {
    icon_path_count=2;
    strcpy(icon_paths[0],"/usr/share/icons");
    strcpy(icon_paths[1],"/usr/local/share/icons");
  }
}

void open_conf(void)
{
  int i;
  
  mw=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(mw),"PortoSeguro Configuration");
  gtk_window_set_default_size(GTK_WINDOW(mw),320,460);
  gtk_widget_realize(mw);

  /* top level */
  wi[0]=gtk_vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER(mw),wi[0]);

  /* notebook */
  wi[22]=gtk_notebook_new();
  gtk_box_pack_start(GTK_BOX(wi[0]),wi[22],TRUE,TRUE,8);
  wi[23]=gtk_label_new("Applications");

  /* applications vbox */
  wi[24]=gtk_vbox_new(FALSE,0);
  gtk_container_set_border_width(GTK_CONTAINER(wi[24]),4);

  ob[3]=GTK_OBJECT(gtk_tooltips_new());

  /* button box */
  wi[3]=gtk_hbox_new(TRUE,0);
  gtk_box_pack_start(GTK_BOX(wi[24]),wi[3],FALSE,TRUE,0);
  gtk_notebook_append_page(GTK_NOTEBOOK(wi[22]),wi[24],wi[23]);

  wi[1]=gtk_scrolled_window_new(NULL,NULL);
  wi[2]=gtk_clist_new(2);
  gtk_clist_set_shadow_type(GTK_CLIST(wi[2]),GTK_SHADOW_IN);
  gtk_clist_set_selection_mode(GTK_CLIST(wi[2]),GTK_SELECTION_SINGLE);
  gtk_clist_column_titles_passive(GTK_CLIST(wi[2]));
  gtk_clist_column_titles_hide(GTK_CLIST(wi[2]));
  gtk_clist_set_column_width(GTK_CLIST(wi[2]),0,64);
  gtk_clist_set_column_width(GTK_CLIST(wi[2]),1,110);
  gtk_clist_set_row_height(GTK_CLIST(wi[2]),64);
  gtk_clist_set_column_auto_resize(GTK_CLIST(wi[2]),1,TRUE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(wi[1]),
				 GTK_POLICY_AUTOMATIC,
				 GTK_POLICY_ALWAYS);
  gtk_container_add(GTK_CONTAINER(wi[1]),wi[2]);
  gtk_box_pack_start(GTK_BOX(wi[24]),wi[1],TRUE,TRUE,0);

  /* buttons */
  wi[4]=make_pix_button(mw,cmd_new_xpm);
  gtk_box_pack_start(GTK_BOX(wi[3]),wi[4],FALSE,TRUE,0);
  wi[5]=make_pix_button(mw,cmd_del_xpm);
  gtk_box_pack_start(GTK_BOX(wi[3]),wi[5],FALSE,TRUE,0);
  wi[6]=make_pix_button(mw,cmd_dup_xpm);
  gtk_box_pack_start(GTK_BOX(wi[3]),wi[6],FALSE,TRUE,0);
  wi[7]=make_pix_button(mw,cmd_up_xpm);
  gtk_box_pack_start(GTK_BOX(wi[3]),wi[7],FALSE,TRUE,0);
  wi[8]=make_pix_button(mw,cmd_down_xpm);
  gtk_box_pack_start(GTK_BOX(wi[3]),wi[8],FALSE,TRUE,0);

  gtk_tooltips_set_tip(GTK_TOOLTIPS(ob[3]),wi[4],"New","New");
  gtk_tooltips_set_tip(GTK_TOOLTIPS(ob[3]),wi[5],"Remove","Remove");
  gtk_tooltips_set_tip(GTK_TOOLTIPS(ob[3]),wi[6],"Duplicate","Duplicate");
  gtk_tooltips_set_tip(GTK_TOOLTIPS(ob[3]),wi[7],"Move up","Move up");
  gtk_tooltips_set_tip(GTK_TOOLTIPS(ob[3]),wi[8],"Move down","Move down");

  wi[9]=gtk_hbox_new(FALSE,2);
  wi[10]=gtk_label_new("Command to execute:");
  wi[11]=gtk_entry_new_with_max_length(512);
  gtk_box_pack_start(GTK_BOX(wi[24]),wi[9],FALSE,TRUE,2);
  gtk_box_pack_start(GTK_BOX(wi[9]),wi[10],FALSE,FALSE,4);
  gtk_box_pack_start(GTK_BOX(wi[9]),wi[11],FALSE,FALSE,4);

  wi[12]=gtk_hbox_new(FALSE,0);
  wi[13]=gtk_check_button_new_with_label("Instance hold");

  wi[14]=gtk_button_new_with_label(" Icon... ");
  gtk_box_pack_start(GTK_BOX(wi[24]),wi[12],FALSE,TRUE,0);
  gtk_box_pack_start(GTK_BOX(wi[12]),wi[13],FALSE,FALSE,0);
  gtk_box_pack_end(GTK_BOX(wi[12]),wi[14],FALSE,FALSE,4);

  gtk_tooltips_set_tip(GTK_TOOLTIPS(ob[3]),wi[13],
		       "Application items with instance hold remain "\
                       "highlighted while an instance of the application "\
                       "is running and execution of more than "\
                       "one instance is inhibited.",
		       "instance_hold");

  /* end of applications pane */

  /* appearance pane */

  wi[25]=gtk_vbox_new(FALSE,0);
  gtk_container_set_border_width(GTK_CONTAINER(wi[25]),4);
  wi[26]=gtk_label_new("Appearance");
  gtk_notebook_append_page(GTK_NOTEBOOK(wi[22]),wi[25],wi[26]);
  
  wi[27]=gtk_frame_new(" Activated Application Color ");
  gtk_frame_set_shadow_type(GTK_FRAME(wi[27]),GTK_SHADOW_ETCHED_IN);
  gtk_container_set_border_width(GTK_CONTAINER(wi[27]),4);
  gtk_box_pack_start(GTK_BOX(wi[25]),wi[27],FALSE,FALSE,2);

  ob[0]=gtk_adjustment_new(active_hue.r,0.00,1.00,0.01,0.01,0);
  ob[1]=gtk_adjustment_new(active_hue.g,0.00,1.00,0.01,0.01,0);
  ob[2]=gtk_adjustment_new(active_hue.b,0.00,1.00,0.01,0.01,0);
  
  wi[28]=gtk_hbox_new(TRUE,2);
  gtk_container_add(GTK_CONTAINER(wi[27]),wi[28]);
  
  wi[29]=gtk_vbox_new(TRUE,0);
  gtk_container_set_border_width(GTK_CONTAINER(wi[29]),6);
  gtk_box_pack_start(GTK_BOX(wi[28]),wi[29],FALSE,TRUE,2);
  
  wi[30]=gtk_label_new("RGB Mask");
  wi[31]=gtk_hscale_new(GTK_ADJUSTMENT(ob[0]));
  gtk_scale_set_digits(GTK_SCALE(wi[31]),2);

  wi[32]=gtk_hscale_new(GTK_ADJUSTMENT(ob[1]));
  gtk_scale_set_digits(GTK_SCALE(wi[32]),2);

  wi[33]=gtk_hscale_new(GTK_ADJUSTMENT(ob[2]));
  gtk_scale_set_digits(GTK_SCALE(wi[33]),2);

  for(i=30;i<=33;i++)
    gtk_box_pack_start(GTK_BOX(wi[29]),wi[i],FALSE,FALSE,0);

  wi[34]=gtk_frame_new(" Preview ");
  gtk_frame_set_shadow_type(GTK_FRAME(wi[34]),GTK_SHADOW_ETCHED_IN);
  gtk_container_set_border_width(GTK_CONTAINER(wi[34]),4);

  wi[35]=gtk_drawing_area_new();
  gtk_widget_set_events(wi[35],GDK_EXPOSURE_MASK);
  gtk_drawing_area_size(GTK_DRAWING_AREA(wi[35]),64,64);

  gtk_box_pack_start(GTK_BOX(wi[28]),wi[34],FALSE,TRUE,3);
  gtk_container_add(GTK_CONTAINER(wi[34]),wi[35]);

  wi[36]=gtk_frame_new(" Placement Corner ");
  gtk_frame_set_shadow_type(GTK_FRAME(wi[36]),GTK_SHADOW_ETCHED_IN);
  gtk_container_set_border_width(GTK_CONTAINER(wi[36]),4);

  wi[38]=gtk_hbox_new(TRUE,0);
  gtk_container_set_border_width(GTK_CONTAINER(wi[38]),5);
  gtk_container_add(GTK_CONTAINER(wi[36]),wi[38]);

  wi[37]=gtk_drawing_area_new();
  gtk_widget_set_events(wi[37],GDK_EXPOSURE_MASK|GDK_BUTTON_PRESS_MASK);
  gtk_drawing_area_size(GTK_DRAWING_AREA(wi[37]),128,96);
  gtk_box_pack_start(GTK_BOX(wi[25]),wi[36],FALSE,TRUE,3);
  gtk_box_pack_start(GTK_BOX(wi[38]),wi[37],FALSE,TRUE,0);

  wi[39]=gtk_frame_new(" Animation Speed ");
  gtk_frame_set_shadow_type(GTK_FRAME(wi[39]),GTK_SHADOW_ETCHED_IN);
  gtk_container_set_border_width(GTK_CONTAINER(wi[39]),4);

  wi[40]=gtk_vbox_new(FALSE,1);
  gtk_container_set_border_width(GTK_CONTAINER(wi[40]),3);
  gtk_container_add(GTK_CONTAINER(wi[39]),wi[40]);
  wi[41]=gtk_hbox_new(FALSE,0);

  wi[42]=gtk_label_new(" Slower");
  wi[43]=gtk_label_new("Faster ");

  gtk_box_pack_start(GTK_BOX(wi[40]),wi[41],FALSE,FALSE,1);
  gtk_box_pack_start(GTK_BOX(wi[41]),wi[42],FALSE,FALSE,1);
  gtk_box_pack_end(GTK_BOX(wi[41]),wi[43],FALSE,FALSE,1);

  ob[4]=gtk_adjustment_new(speed,0.00,4.00,1.00,1.00,0);
  wi[44]=gtk_hscale_new(GTK_ADJUSTMENT(ob[4]));
  gtk_scale_set_digits(GTK_SCALE(wi[44]),0);

  gtk_box_pack_start(GTK_BOX(wi[40]),wi[44],FALSE,FALSE,1);

  gtk_box_pack_start(GTK_BOX(wi[25]),wi[39],FALSE,TRUE,3);
  
  /* end of appearance pane */

  /* pixmap path pane */

  wj[0]=gtk_vbox_new(FALSE,0);
  gtk_container_set_border_width(GTK_CONTAINER(wj[0]),4);
  wj[1]=gtk_label_new("Icon Paths");
  gtk_notebook_append_page(GTK_NOTEBOOK(wi[22]),wj[0],wj[1]);

  wj[2]=gtk_scrolled_window_new(NULL,NULL);
  wj[3]=gtk_clist_new(1);
  gtk_clist_set_shadow_type(GTK_CLIST(wj[3]),GTK_SHADOW_IN);
  gtk_clist_set_selection_mode(GTK_CLIST(wj[3]),GTK_SELECTION_SINGLE);
  gtk_clist_column_titles_passive(GTK_CLIST(wj[3]));
  gtk_clist_column_titles_hide(GTK_CLIST(wj[3]));
  gtk_clist_set_column_auto_resize(GTK_CLIST(wj[3]),0,TRUE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(wi[1]),
				 GTK_POLICY_AUTOMATIC,
				 GTK_POLICY_ALWAYS);
  gtk_container_add(GTK_CONTAINER(wj[2]),wj[3]);
  gtk_box_pack_start(GTK_BOX(wj[0]),wj[2],TRUE,TRUE,0);

  wj[4]=gtk_hbox_new(FALSE,0);
  wj[5]=gtk_button_new_with_label(" Remove ");

  wj[6]=gtk_hbox_new(FALSE,0);
  wj[7]=gtk_entry_new();
  wj[8]=gtk_button_new_with_label(" Add ");

  gtk_box_pack_start(GTK_BOX(wj[0]),wj[4],FALSE,TRUE,2);
  gtk_box_pack_end(GTK_BOX(wj[4]),wj[5],FALSE,FALSE,2);

  gtk_box_pack_start(GTK_BOX(wj[0]),wj[6],FALSE,TRUE,2);
  gtk_box_pack_start(GTK_BOX(wj[6]),wj[7],TRUE,TRUE,2);
  gtk_box_pack_start(GTK_BOX(wj[6]),wj[8],FALSE,TRUE,2);

  gtk_widget_set_sensitive(wj[5],FALSE);

  /* end of pixmap path pane */

  wi[15]=gtk_hseparator_new();
  gtk_box_pack_start(GTK_BOX(wi[0]),wi[15],FALSE,TRUE,4);

  wi[16]=gtk_hbox_new(TRUE,0);
  wi[17]=gtk_label_new(" ");
  wi[18]=gtk_label_new(" ");
  wi[19]=gtk_button_new_with_label(" OK ");
  wi[20]=gtk_button_new_with_label(" Apply ");
  wi[21]=gtk_button_new_with_label(" Cancel ");

  gtk_box_pack_start(GTK_BOX(wi[0]),wi[16],FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX(wi[16]),wi[17],FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX(wi[16]),wi[18],FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX(wi[16]),wi[19],FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX(wi[16]),wi[20],FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX(wi[16]),wi[21],FALSE,TRUE,4);

  for(i=0;i<45;i++)
    gtk_widget_show(wi[i]);
  for(i=0;i<9;i++)
    gtk_widget_show(wj[i]);
  gtk_widget_show(mw);

  gtk_signal_connect(GTK_OBJECT(wi[35]),"expose_event",
		     GTK_SIGNAL_FUNC(hue_expose),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[37]),"expose_event",
		     GTK_SIGNAL_FUNC(corner_expose),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[37]),"button_press_event",
		     GTK_SIGNAL_FUNC(corner_click),NULL);

  for(i=0;i<3;i++)
    gtk_signal_connect(GTK_OBJECT(ob[i]),"value_changed",
		       GTK_SIGNAL_FUNC(hue_update),NULL);
  gtk_signal_connect(GTK_OBJECT(ob[4]),"value_changed",
		     GTK_SIGNAL_FUNC(speed_update),NULL);

  gtk_signal_connect(GTK_OBJECT(mw),"delete_event",
		     GTK_SIGNAL_FUNC(die),NULL);
  gtk_signal_connect(GTK_OBJECT(mw),"destroy",
		     GTK_SIGNAL_FUNC(dead),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[21]),"clicked",
		     GTK_SIGNAL_FUNC(b_cancel),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[19]),"clicked",
		     GTK_SIGNAL_FUNC(b_ok),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[20]),"clicked",
		     GTK_SIGNAL_FUNC(b_apply),NULL);

  gtk_signal_connect(GTK_OBJECT(wi[14]),"clicked",
		     GTK_SIGNAL_FUNC(pick_icon),NULL);

  gtk_signal_connect(GTK_OBJECT(wi[4]),"clicked",
		     GTK_SIGNAL_FUNC(list_add),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[6]),"clicked",
		     GTK_SIGNAL_FUNC(list_duplicate),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[5]),"clicked",
		     GTK_SIGNAL_FUNC(list_remove),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[7]),"clicked",
		     GTK_SIGNAL_FUNC(list_moveup),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[8]),"clicked",
		     GTK_SIGNAL_FUNC(list_movedown),NULL);
  gtk_signal_connect(GTK_OBJECT(wi[11]),"changed",
		     GTK_SIGNAL_FUNC(ch_label),NULL);
  gtk_signal_connect (GTK_OBJECT (wi[2]), "select_row",
		      GTK_SIGNAL_FUNC (list_select), NULL);
  gtk_signal_connect (GTK_OBJECT (wi[2]), "unselect_row",
		      GTK_SIGNAL_FUNC (list_unselect), NULL);

  gtk_signal_connect (GTK_OBJECT (wj[3]), "select_row",
		      GTK_SIGNAL_FUNC (pixpath_select), NULL);
  gtk_signal_connect (GTK_OBJECT (wj[3]), "unselect_row",
		      GTK_SIGNAL_FUNC (pixpath_unselect), NULL);
  gtk_signal_connect(GTK_OBJECT(wj[5]),"clicked",
		     GTK_SIGNAL_FUNC(pixpath_remove),NULL);
  gtk_signal_connect(GTK_OBJECT(wj[8]),"clicked",
		     GTK_SIGNAL_FUNC(pixpath_add),NULL);

  clear_pane();
}

/* appearance pane */

void hue_update(GtkAdjustment *a,gpointer data) {
  active_hue.r=GTK_ADJUSTMENT(ob[0])->value;
  active_hue.g=GTK_ADJUSTMENT(ob[1])->value;
  active_hue.b=GTK_ADJUSTMENT(ob[2])->value;
  gtk_widget_queue_resize(wi[35]);
}

void speed_update(GtkAdjustment *a,gpointer data) {
  speed=GTK_ADJUSTMENT(ob[4])->value;
}

gboolean hue_expose(GtkWidget *a,GdkEventExpose *b,gpointer c)
{
  char *buf;
  
  buf=make_rgb_mix_file("anyone",graydock_xpm,&active_hue);

  gdk_draw_rgb_image(a->window,
		     a->style->fg_gc[GTK_WIDGET_STATE(a)],
		     3,3,
		     64,64,
		     GDK_RGB_DITHER_NORMAL,
		     buf,
		     3*64);

  g_free(buf);
  return FALSE;
}

gboolean corner_expose(GtkWidget *a,GdkEventExpose *b,gpointer c)
{
  GdkGC *gc;
  int x,y;

  gc=gdk_gc_new(a->window);
  gdk_rgb_gc_set_foreground(gc,0x5a6d83);
  gdk_draw_rectangle(a->window,gc,TRUE,0,0,127,95);
  gdk_rgb_gc_set_foreground(gc,0x6a7d93);
  gdk_draw_line(a->window,gc,0,48,127,48);
  gdk_draw_line(a->window,gc,64,0,64,95);
  gdk_rgb_gc_set_foreground(gc,0x000000);
  gdk_draw_rectangle(a->window,gc,FALSE,0,0,127,95);

  x=y=1;
  if (halign)
    x=127-10;
  if (valign)
    y=95-10*5;

  gdk_rgb_gc_set_foreground(gc,0xd0d0d0);
  gdk_draw_rectangle(a->window,gc,TRUE,x,y,9,49);
  gdk_rgb_gc_set_foreground(gc,0x000000);
  gdk_draw_rectangle(a->window,gc,FALSE,x,y,9,49);

  gdk_gc_destroy(gc);
  return FALSE;
}

gboolean corner_click(GtkWidget *a,GdkEventButton *geb,gpointer data)
{
  int x,y;
  if (!geb)
    return FALSE;

  x=(int)(geb->x);
  y=(int)(geb->y);

  halign=valign=0;
  if (x>64) ++halign;
  if (y>48) ++valign;

  gtk_widget_queue_resize(wi[37]);
  return FALSE;
}

/* appearance pane */


GtkWidget *make_pix_button(GtkWidget *w,char **src)
{
  GtkStyle *sty;
  GdkPixmap *pic;
  GdkBitmap *mask;
  GtkWidget *a,*b;
  sty=gtk_widget_get_style(w);
  pic=gdk_pixmap_create_from_xpm_d (w->window, &mask,
				   &sty->bg[GTK_STATE_NORMAL],
				   (gchar **) src);
  a=gtk_pixmap_new(pic,mask);
  gtk_widget_show(a);
  gdk_pixmap_unref(pic);
  b=gtk_button_new();
  gtk_container_add(GTK_CONTAINER(b),a);
  return(b);
}

gboolean die(GtkWidget *w,GdkEvent *e,gpointer data)
{
  return FALSE;
}

gboolean dead(GtkWidget *w,gpointer data)
{
  gtk_main_quit();
  return FALSE;
}

void b_cancel(GtkWidget *w,gpointer data)
{
  gtk_widget_destroy(mw);
}

void b_ok(GtkWidget *w,gpointer data)
{
  read_back();
  save_rc();
  gtk_widget_destroy(mw);
}

void b_apply(GtkWidget *w,gpointer data)
{
  read_back();
  save_rc();
}

void update_list(void)
{
  int i;
  char *q,*pp[2];
  GtkStyle  *style;
  GdkBitmap *mask;
  GdkPixmap *tp;

  style=gtk_widget_get_style(mw);

  gtk_clist_freeze(GTK_CLIST(wi[2]));
  gtk_clist_clear(GTK_CLIST(wi[2]));
    
  for(i=0;i<bcount;i++) {
    tp = gdk_pixmap_create_from_xpm (mw->window, &mask,
				     &style->bg[GTK_STATE_NORMAL],
				     bdock[i].icon);
    if (tp==NULL)
      tp = gdk_pixmap_create_from_xpm_d (mw->window, &mask,
				       &style->bg[GTK_STATE_NORMAL],
				       graydock_xpm);
    q=bdock[i].exec;
    pp[0]=pp[1]=q;
    gtk_clist_append(GTK_CLIST(wi[2]),pp);
    gtk_clist_set_pixmap(GTK_CLIST(wi[2]),i,0,tp,mask);
    gtk_clist_set_text(GTK_CLIST(wi[2]),i,1,q);
    gtk_clist_set_shift(GTK_CLIST(wi[2]),i,0,0,0);
    gtk_clist_set_shift(GTK_CLIST(wi[2]),i,1,26,0);
    gdk_pixmap_unref(tp);
  }

  if (selected_entry>=0)
    gtk_clist_select_row(GTK_CLIST(wi[2]),selected_entry,0);
  gtk_clist_thaw(GTK_CLIST(wi[2]));

  /* pixmap paths */
  gtk_clist_freeze(GTK_CLIST(wj[3]));
  gtk_clist_clear(GTK_CLIST(wj[3]));

  for(i=0;i<icon_path_count;i++) {
    pp[0]=icon_paths[i];
    gtk_clist_append(GTK_CLIST(wj[3]),pp);
  }

  gtk_widget_set_sensitive(wj[5],FALSE);
  cur_pixpath=-1;

  gtk_clist_thaw(GTK_CLIST(wj[3]));
}

/* buttons */

void
list_moveup(GtkWidget *gw,gpointer data)
{
  int j;
  struct PortoSeguro tmp;
  j=selected_entry;
  read_back();
  selected_entry=-1;  
  clear_pane();
  memcpy(&tmp,&bdock[j],sizeof(struct PortoSeguro));
  memcpy(&bdock[j],&bdock[j-1],sizeof(struct PortoSeguro));
  memcpy(&bdock[j-1],&tmp,sizeof(struct PortoSeguro));
  update_list();
  gtk_clist_select_row(GTK_CLIST(wi[2]),j-1,0);
}

void
list_movedown(GtkWidget *gw,gpointer data)
{
  int j;
  struct PortoSeguro tmp;
  j=selected_entry;
  read_back();
  selected_entry=-1;  
  clear_pane();
  memcpy(&tmp,&bdock[j],sizeof(struct PortoSeguro));
  memcpy(&bdock[j],&bdock[j+1],sizeof(struct PortoSeguro));
  memcpy(&bdock[j+1],&tmp,sizeof(struct PortoSeguro));
  update_list();
  gtk_clist_select_row(GTK_CLIST(wi[2]),j+1,0);
}

void read_back(void)
{
  if (selected_entry<0)
    return;
  strcpy(bdock[selected_entry].exec,
	 gtk_entry_get_text(GTK_ENTRY(wi[11])));
  bdock[selected_entry].hold=!!gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(wi[13]));
}

void clear_pane(void)
{
  gtk_editable_select_region(GTK_EDITABLE(wi[11]),0,-1);
  gtk_editable_delete_selection(GTK_EDITABLE(wi[11]));
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wi[13]),FALSE);
  gtk_widget_set_sensitive(wi[5],FALSE);
  gtk_widget_set_sensitive(wi[6],FALSE);
  gtk_widget_set_sensitive(wi[7],FALSE);
  gtk_widget_set_sensitive(wi[8],FALSE);
  gtk_widget_set_sensitive(wi[11],FALSE);
  gtk_widget_set_sensitive(wi[13],FALSE);
  gtk_widget_set_sensitive(wi[14],FALSE);
}

void update_pane(void)
{
  gtk_widget_set_sensitive(wi[5],TRUE);
  gtk_widget_set_sensitive(wi[6],TRUE);
  if (selected_entry>0)
    gtk_widget_set_sensitive(wi[7],TRUE);
  if (selected_entry<(bcount-1))
    gtk_widget_set_sensitive(wi[8],TRUE);
  gtk_widget_set_sensitive(wi[11],TRUE);
  gtk_widget_set_sensitive(wi[13],TRUE);
  gtk_widget_set_sensitive(wi[14],TRUE);
  gtk_entry_set_text(GTK_ENTRY(wi[11]),bdock[selected_entry].exec);
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(wi[13]),
			       !!bdock[selected_entry].hold);
}

void ch_label(GtkEditable *ge,gpointer data)
{
  if (selected_entry<0) return;
  strcpy(bdock[selected_entry].exec,
	 gtk_entry_get_text(GTK_ENTRY(ge)));
  gtk_clist_set_text(GTK_CLIST(wi[2]),selected_entry,1,
		     bdock[selected_entry].exec);
}

void list_select(GtkCList *cl,
		 gint row,
		 gint column,
		 GdkEventButton *geb,
		 gpointer data)
{
  selected_entry=row;
  update_pane();
}

void list_unselect(GtkCList *cl,
		   gint row,
		   gint column,
		   GdkEventButton *geb,
		   gpointer data)
{
  read_back();
  selected_entry=-1;
  clear_pane();
}

void list_add(GtkWidget *gw,gpointer data)
{
  int i;
  struct PortoSeguro *ne;

  i=selected_entry;
  read_back();
  selected_entry=-1;
  clear_pane();

  ne=&bdock[bcount];
  memset(ne,0,sizeof(struct PortoSeguro));

  strcpy(ne->exec,"command");
  strcpy(ne->icon,"sapphire.xpm");
  ne->hold=1;
  ne->applet=0;
  selected_entry=bcount;
  bcount++;
  
  update_list();
  update_pane();
  gtk_clist_select_row(GTK_CLIST(wi[2]),selected_entry,0);
  gtk_clist_moveto(GTK_CLIST(wi[2]),selected_entry,0,0.5,0.0);
}

void list_duplicate(GtkWidget *gw,gpointer data)
{
  char tmp[128];
  int i;
  read_back();
  i=selected_entry;
  memcpy(&bdock[bcount],&bdock[i],
	 sizeof(struct PortoSeguro));
  selected_entry=-1;
  clear_pane();
  sprintf(tmp,"%s",bdock[i].exec);
  strcpy(bdock[bcount].exec,tmp);
  bcount++;
  update_list();
  gtk_clist_select_row(GTK_CLIST(wi[2]),i,0);
}

void list_remove(GtkWidget *gw,gpointer data)
{
  int i,j;

  j=selected_entry;
  selected_entry=-1;
  clear_pane();

  for(i=j;i<(bcount-1);i++)
    memcpy(&bdock[i],&bdock[i+1],
	   sizeof(struct PortoSeguro));
  bcount--;
  update_list();
}


GtkWidget *ic[20];
GList *icons=NULL;
char *pick=NULL;
GdkPixmap *icon_preview=NULL;

/* icon list */
void pick_icon(GtkWidget *gw,gpointer data)
{
  int i;
  
  ic[0]=gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW(ic[0]),"Choose an icon");
  gtk_window_set_transient_for(GTK_WINDOW(ic[0]),GTK_WINDOW(mw));
  gtk_window_set_default_size(GTK_WINDOW(ic[0]),550,300);
  gtk_widget_realize(ic[0]);

  ic[3]=gtk_vbox_new(FALSE,0);

  ic[4]=gtk_table_new(1,3,TRUE);

  ic[5]=gtk_hbox_new(TRUE,4);
  ic[6]=gtk_hseparator_new();

  gtk_container_add(GTK_CONTAINER(ic[0]),ic[3]);
  
  ic[1]=gtk_scrolled_window_new(NULL,NULL);

  ic[2]=gtk_clist_new(1);
  gtk_clist_set_shadow_type(GTK_CLIST(ic[2]),GTK_SHADOW_IN);
  gtk_clist_set_selection_mode(GTK_CLIST(ic[2]),GTK_SELECTION_SINGLE);
  gtk_clist_column_titles_passive(GTK_CLIST(ic[2]));
  gtk_clist_column_titles_hide(GTK_CLIST(ic[2]));
  gtk_clist_set_column_auto_resize(GTK_CLIST(ic[2]),0,TRUE);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(ic[1]),
				 GTK_POLICY_AUTOMATIC,
				 GTK_POLICY_ALWAYS);
  gtk_container_set_border_width(GTK_CONTAINER(ic[1]),4);
  gtk_container_add(GTK_CONTAINER(ic[1]),ic[2]);

  gtk_box_pack_start(GTK_BOX(ic[3]),ic[4],TRUE,TRUE,0);

  gtk_table_attach_defaults(GTK_TABLE(ic[4]),ic[1],0,2,0,1);

  gtk_box_pack_start(GTK_BOX(ic[3]),ic[6],FALSE,TRUE,4);
  gtk_box_pack_start(GTK_BOX(ic[3]),ic[5],FALSE,TRUE,4);

  ic[7]=gtk_label_new(" ");
  ic[8]=gtk_label_new(" ");
  ic[9]=gtk_label_new(" ");
  ic[10]=gtk_label_new(" ");
  ic[11]=gtk_button_new_with_label(" OK ");
  ic[12]=gtk_button_new_with_label(" Cancel ");

  for(i=7;i<13;i++)
    gtk_box_pack_start(GTK_BOX(ic[5]),ic[i],FALSE,TRUE,6);

  ic[13]=gtk_frame_new(" Preview ");
  gtk_container_set_border_width(GTK_CONTAINER(ic[13]),4);
  gtk_frame_set_shadow_type(GTK_FRAME(ic[13]),GTK_SHADOW_ETCHED_IN);
  ic[14]=gtk_drawing_area_new();
  gtk_widget_set_events(ic[14],GDK_EXPOSURE_MASK);
  gtk_drawing_area_size(GTK_DRAWING_AREA(ic[14]),64,64);
  gtk_container_add(GTK_CONTAINER(ic[13]),ic[14]);
  gtk_table_attach_defaults(GTK_TABLE(ic[4]),ic[13],2,3,0,1);

  for(i=0;i<15;i++)
    gtk_widget_show(ic[i]);
  gtk_grab_add(ic[0]);

  gtk_signal_connect(GTK_OBJECT(ic[14]),"configure_event",
		     GTK_SIGNAL_FUNC(icon_config),NULL);
  gtk_signal_connect(GTK_OBJECT(ic[14]),"expose_event",
		     GTK_SIGNAL_FUNC(icon_expose),NULL);

  gtk_signal_connect(GTK_OBJECT(ic[0]),"delete_event",
		     GTK_SIGNAL_FUNC(die),NULL);
  gtk_signal_connect(GTK_OBJECT(ic[0]),"destroy",
		     GTK_SIGNAL_FUNC(icon_dead),NULL);
  gtk_signal_connect(GTK_OBJECT(ic[2]),"select_row",
		     GTK_SIGNAL_FUNC(icon_picked),NULL);

  gtk_signal_connect(GTK_OBJECT(ic[11]),"clicked",
		     GTK_SIGNAL_FUNC(icon_ok),NULL);
  gtk_signal_connect(GTK_OBJECT(ic[12]),"clicked",
		     GTK_SIGNAL_FUNC(icon_cancel),NULL);

  upload_icons();
}

void upload_icons(void)
{
  GList *pt;
  struct dirent *dentry;
  DIR *curd;
  char *p,*q,*pp[1];
  int i,j,goatit=-1;

  free_icon_list();

  for(i=0;i<icon_path_count;i++) {
    curd=opendir(icon_paths[i]);
    if (!curd)
      continue;
    while((dentry=readdir(curd))!=NULL) {
      p=dentry->d_name;
      j=strlen(p);
      if (j<4) continue;
      if (!strcasecmp(p+j-3,"xpm")) {
	q=(char *)g_malloc0(strlen(p)+strlen(icon_paths[i])+3);
	sprintf(q,"%s/%s",icon_paths[i],p);
	icons=g_list_append(icons,(gpointer)q);
      }
    }
    closedir(curd);
  }

  pp[0]=" ";
  gtk_clist_freeze(GTK_CLIST(ic[2]));
  for(i=0,pt=icons;pt!=NULL;pt=g_list_next(pt),i++) {
    pp[0]=(char *)(pt->data);
    gtk_clist_append(GTK_CLIST(ic[2]),pp);
    if (!strcmp(bdock[selected_entry].icon,pp[0])) {
      gtk_clist_select_row(GTK_CLIST(ic[2]),i,0);
      goatit=i;
    }
  }
  gtk_clist_thaw(GTK_CLIST(ic[2]));
  if (goatit>=0)
    gtk_clist_moveto(GTK_CLIST(ic[2]),goatit,0,0.0,0.0);
}

void free_icon_list(void)
{
  GList *pt;
  if (icons!=NULL) {
    for(pt=icons;pt!=NULL;pt=g_list_next(pt))
      g_free((gpointer)(pt->data));
    g_list_free(icons);
    icons=NULL;
  }
}

void icon_picked(GtkCList *cl,
		 gint row,
		 gint column,
		 GdkEventButton *geb,
		 gpointer data)
{
  pick=(char *)g_list_nth_data(icons,row);
  gtk_widget_queue_resize(ic[13]);
}

void icon_ok(GtkWidget *a,gpointer b)
{
  if (pick==NULL)
    return;
  read_back();
  strcpy(bdock[selected_entry].icon,pick);
  gtk_grab_remove(ic[0]);
  gtk_widget_destroy(ic[0]);
  update_list();
}

void icon_cancel(GtkWidget *a,gpointer b)
{
  gtk_grab_remove(ic[0]);
  gtk_widget_destroy(ic[0]);
}

gboolean icon_dead(GtkWidget *a,gpointer b)
{
  free_icon_list();
  return FALSE;
}

gboolean icon_config(GtkWidget *a,GdkEventConfigure *b,gpointer c)
{
  GdkBitmap *mask;
  if (icon_preview!=NULL) {
    gdk_pixmap_unref(icon_preview);
    icon_preview=NULL;
  }
  if (pick!=NULL)
    icon_preview=gdk_pixmap_create_from_xpm(a->window,
					    &mask,
					    &(a->style->bg[GTK_STATE_NORMAL]),
					    pick);
  return TRUE;
}

gboolean icon_expose(GtkWidget *a,GdkEventExpose *b,gpointer c)
{
  if (icon_preview!=NULL) {
    gdk_draw_pixmap(a->window,
		    a->style->fg_gc[GTK_WIDGET_STATE(a)],
		    icon_preview,
		    0,0,
		    8,8,
		    a->allocation.width,
		    a->allocation.height);
  }
  return FALSE;
}

/* pix path */

void pixpath_select(GtkCList *cl,
		    gint row,
		    gint column,
		    GdkEventButton *geb,
		    gpointer data)
{
  cur_pixpath=row;
  gtk_widget_set_sensitive(wj[5],TRUE);
  gtk_entry_set_text(GTK_ENTRY(wj[7]),icon_paths[row]);
}

void pixpath_unselect(GtkCList *cl,
		      gint row,
		      gint column,
		      GdkEventButton *geb,
		      gpointer data)
{
  cur_pixpath=-1;
  gtk_widget_set_sensitive(wj[5],FALSE);
}

void pixpath_remove(GtkWidget *a,gpointer b)
{
  int i;

  icon_path_count--;
  for(i=cur_pixpath;i<icon_path_count;i++)
    strcpy(icon_paths[i],icon_paths[i+1]);

  update_list();
}

void pixpath_add(GtkWidget *a,gpointer b)
{
  strcpy(icon_paths[icon_path_count],
	 gtk_entry_get_text(GTK_ENTRY(wj[7])));
  if (strlen(icon_paths[icon_path_count]))
    icon_path_count++;
  update_list();
}
