
#ifndef PortoSeguro_CONF_H
#define PortoSeguro_CONF_H

#include <gtk/gtk.h>

struct PortoSeguro {
  char icon[256];
  char exec[512];
  int  hold;
  int  applet;
  GtkWidget *square;
  char *gray,*purple;
  int running;
  int pid;
};

void read_rc(void);
void save_rc(void);
void open_conf(void);
void update_list(void);

void read_back(void);
void clear_pane(void);

void upload_icons(void);
void free_icon_list(void);

void b_ok(GtkWidget *w,gpointer data);
void b_apply(GtkWidget *w,gpointer data);
void b_cancel(GtkWidget *w,gpointer data);

GtkWidget *make_pix_button(GtkWidget *w,char **src);
gboolean die(GtkWidget *w,GdkEvent *e,gpointer data);
gboolean dead(GtkWidget *w,gpointer data);
void list_add(GtkWidget *gw,gpointer data);
void list_duplicate(GtkWidget *gw,gpointer data);
void list_remove(GtkWidget *gw,gpointer data);
void list_movedown(GtkWidget *gw,gpointer data);
void list_moveup(GtkWidget *gw,gpointer data);
void ch_label(GtkEditable *ge,gpointer data);
void list_unselect(GtkCList *cl,
		   gint row,
		   gint column,
		   GdkEventButton *geb,
		   gpointer data);

void list_select(GtkCList *cl,
		 gint row,
		 gint column,
		 GdkEventButton *geb,
		 gpointer data);

void pick_icon(GtkWidget *gw,gpointer data);
void icon_picked(GtkCList *cl,
		 gint row,
		 gint column,
		 GdkEventButton *geb,
		 gpointer data);

void pixpath_select(GtkCList *cl,
		    gint row,
		    gint column,
		    GdkEventButton *geb,
		    gpointer data);

void pixpath_unselect(GtkCList *cl,
		      gint row,
		      gint column,
		      GdkEventButton *geb,
		      gpointer data);

void pixpath_remove(GtkWidget *a,gpointer b);
void pixpath_add(GtkWidget *a,gpointer b);

gboolean icon_dead(GtkWidget *a,gpointer b);
gboolean icon_config(GtkWidget *a,GdkEventConfigure *b,gpointer c);
gboolean icon_expose(GtkWidget *a,GdkEventExpose *b,gpointer c);
void icon_ok(GtkWidget *a,gpointer b);
void icon_cancel(GtkWidget *a,gpointer b);

gboolean hue_expose(GtkWidget *a,GdkEventExpose *b,gpointer c);
void hue_update(GtkAdjustment *a,gpointer data);
gboolean corner_expose(GtkWidget *a,GdkEventExpose *b,gpointer c);
gboolean corner_click(GtkWidget *a,GdkEventButton *geb,gpointer data);

void speed_update(GtkAdjustment *a,gpointer data);

#endif
