/*

    PortoSeguro - Light Application Launcher
    Copyright (C) 2000 Felipe Paulo Guazzi Bergo
    bergo@seul.org

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <X11/xpm.h>
#include "pixmap.h"

char *make_rgb_image_prop(char **back,struct HueMask *hm) {
  unsigned char r[1024],g[1024],b[1024];
  unsigned long map[1024],vmap,trans;
  char *p,loc[2048];
  unsigned char *buf;
  int i,j,k;
  long rgb;

  int nc,x,y,bpp;

  buf=g_malloc0(64*64*3);
  strcpy(loc,back[0]);
  x=atoi(strtok(loc," \t\n"));
  y=atoi(strtok(NULL," \t\n"));
  nc=atoi(strtok(NULL," \t\n"));
  bpp=atoi(strtok(NULL," \t\n"));

  for(i=0;i<nc;i++) {
    strcpy(loc,back[i+1]);
    map[i]=(long)(loc[0]);
    p=strtok(loc," #\t\n");
    p=strtok(NULL," #\t\n");
    if (strlen(p)==1)
      p=strtok(NULL," #\t\n");
    if (strstr(p,"one")) {
      rgb=0x000000;
      trans=map[i];
    }  else {
      if (strlen(p)==12) {
	p[2]=p[4];
	p[3]=p[5];
	p[4]=p[8];
	p[5]=p[9];
	p[6]=0;
      }
      if (strlen(p)==24) {
	p[2]=p[8];
	p[3]=p[9];
	p[4]=p[16];
	p[5]=p[17];
	p[6]=0;
      }
      rgb=strtol(p,NULL,16);
    }
    r[i]=(rgb>>16)&0xff;
    g[i]=(rgb>>8)&0xff;
    b[i]=rgb&0xff;
  }

  for(i=0;i<x;i++)
    for(j=0;j<y;j++) {
      vmap=(long)(back[1+nc+j][i]);
      for(k=0;k<nc;k++)
	if (map[k]==vmap) {
	  *(buf+3*(x*j+i))=r[k];
	  *(buf+3*(x*j+i)+1)=g[k];
	  *(buf+3*(x*j+i)+2)=b[k];
	  break;
	}
    }

  if (hm!=NULL)
    apply_hue_mask(buf,64,64,hm);

  for(i=0;i<x;i++)
    for(j=0;j<y;j++) {
      vmap=(long)(back[1+nc+j][i]);
      if (vmap==trans) {
	  *(buf+3*(x*j+i))=0xc0;
	  *(buf+3*(x*j+i)+1)=0xc0;
	  *(buf+3*(x*j+i)+2)=0xc0;	
      }
    }
  return buf;
}

void make_rgb_image_foreground(char *buf,char **pixmapdata)
{
  unsigned char r[1024],g[1024],b[1024];
  unsigned long map[1024],vmap,trans;
  char *p,loc[2048];
  char **over,*po;
  int i,j,k,rx,ry;
  long rgb;

  int x,y;
  int dnc,dx,dy,dbpp;

  x=y=64;
  over=pixmapdata;
  strcpy(loc,over[0]);
  dx=atoi(strtok(loc," \t\n"));
  dy=atoi(strtok(NULL," \t\n"));
  dnc=atoi(strtok(NULL," \t\n"));
  dbpp=atoi(strtok(NULL," \t\n"));    

  rx=(x-dx)/2;
  ry=(y-dy)/2;
  if (rx<0) rx=0;
  if (ry<0) ry=0;
  if (dx>64) dx=64;
  if (dy>64) dy=64;
  
  for(i=0;i<dnc;i++) {
    strcpy(loc,over[i+1]);
    switch(dbpp) {
    case 1:
      map[i]=((long)loc[0])+(32L<<8)+(32L<<16);
      break;
    case 2:
      map[i]=((long)loc[0])+(((long)loc[1])<<8)+(32L<<16);
      break;
    case 3:
      map[i]=((long)loc[0])+(((long)loc[1])<<8)+(((long)loc[2])<<16);
      break;
    default:
      map[i]=0;
    }
    p=strtok(loc," #\t\n");
    p=strtok(NULL," #\t\n");
    if (strlen(p)==1)
      p=strtok(NULL," #\t\n");
    if (strstr(p,"one")) {
      rgb=0;
      trans=map[i];
    } else {
      if (strlen(p)==12) {
	p[2]=p[4];
	p[3]=p[5];
	p[4]=p[8];
	p[5]=p[9];
	p[6]=0;
      }
      if (strlen(p)==24) {
	p[2]=p[8];
	p[3]=p[9];
	p[4]=p[16];
	p[5]=p[17];
	p[6]=0;
      }
      rgb=strtol(p,NULL,16);
    }
    r[i]=(rgb>>16)&0xff;
    g[i]=(rgb>>8)&0xff;
    b[i]=rgb&0xff;
  }
  
  for(i=0;i<dx;i++)
    for(j=0;j<dy;j++) {
      po=&over[1+dnc+j][i*dbpp];
      switch(dbpp) {
      case 1:
	vmap=((long)po[0])+(32L<<8)+(32L<<16);
	break;
      case 2:
	vmap=((long)po[0])+(((long)po[1])<<8)+(32L<<16);
	break;
      case 3:
	vmap=((long)po[0])+(((long)po[1])<<8)+(((long)po[2])<<16);
	break;
      default:
	vmap=0;
      }
      for(k=0;k<dnc;k++)
	if ((map[k]==vmap)&&(vmap!=trans)) {
	  *(buf+3*(x*(j+ry)+i+rx))=r[k];
	  *(buf+3*(x*(j+ry)+i+rx)+1)=g[k];
	  *(buf+3*(x*(j+ry)+i+rx)+2)=b[k];
	  break;
	}	
    }
}

char *make_rgb_mix_file(char *xpmfile,char **back,struct HueMask *hm)
{
  char *buf;
  char **over;

  buf=make_rgb_image_prop(back,hm);
  if (XpmReadFileToData(xpmfile,&(over))==XpmSuccess) {
    make_rgb_image_foreground(buf,over);
    XpmFree(over);
  }
  return(buf);
}

char *make_rgb_mix_data(char **xpmdata,char **back,struct HueMask *hm)
{
  char *buf;
  buf=make_rgb_image_prop(back,hm);
  make_rgb_image_foreground(buf,xpmdata);
  return(buf);
}

void apply_hue_mask(unsigned char *img,int w,int h,struct HueMask *hm)
{
  int i,j;
  double v;
  unsigned char *p;

  j=w*h;
  p=img;
  for(i=0;i<j;i++) {
    v=(double) (*p);
    v*=hm->r;
    *p=(unsigned char)v;
    v=(double) (*(++p));
    v*=hm->g;
    *p=(unsigned char)v;
    v=(double) (*(++p));
    v*=hm->b;
    *p=(unsigned char)v;
    ++p;
  }
}

/* morphs src and dest. pond=0.0 is src only, pond=1.0 is dest only */
char *rgb_morph(unsigned char *src,unsigned char *dest,double pond)
{
  unsigned char *p,*q,*r,*buf;
  double v,ipond;
  int i;

  buf=(unsigned char *)g_malloc(64*64*3);

  p=src;
  q=dest;
  r=buf;

  if (pond>1.0) pond=1.0;
  if (pond<0.0) pond=0.0;
  ipond=1.0-pond;

  for(i=0;i<(64*64*3);i++,p++,q++,r++) {
    v=ipond*((double)(*p))+pond*((double)(*q));
    (*r)=(unsigned char)(v);
  }

  return(buf);
}

/* compresses image horizontaly to 1/3 its size */

/* currently it is not needed, I made this for a compressing scheme
   that left all buttons visible but smaller. After that  I decided
   for the animated hide scheme, but leave this function here, it may
   be useful in the future */
void compress_img(unsigned char *img)
{
  int i,j,k;
  unsigned char *p,*q;
  double r,g,b;

  for(i=0;i<64;i++)
    for(j=0;j<21;j++) {
      p=img+(64*i+j)*3;
      q=img+(64*i+j*3)*3;
      r=(double)(*(q++));
      g=(double)(*(q++));
      b=(double)(*(q++));
      for(k=0;k<2;k++) {
	r+=(double)(*(q++));
	g+=(double)(*(q++));
	b+=(double)(*(q++));
      }
      r/=3.0;
      g/=3.0;
      b/=3.0;
      *(p++)=(unsigned char)r;
      *(p++)=(unsigned char)g;
      *(p)=(unsigned char)b;
    }
}
